"""
    MoinMoin - RandomQuote Macro

    Copyright (c) 2002 by Jrgen Hermann <jh@web.de>
    All rights reserved, see COPYING for details.
    Originally written by Thomas Waldmann.

    Selects a random quote from FortuneCookies or a given page.

    Usage:
        [[RandomQuote()]]
        [[RandomQuote(WikiTips)]]
    
    Comments:
        It will look for list delimiters on the page in question.
        It will ignore anything that is not in an "*" list.

    $Id: RandomQuote.py,v 1.3 2003/06/05 17:00:09 thomaswaldmann Exp $
"""

import random
from MoinMoin.Page import Page


def execute(macro, args):
    _ = macro.request.getText

    pagename = args or 'FortuneCookies'
    raw = Page(pagename).get_raw_body()
    # CNC:2003-05-30
    if not macro.request.user.may.read(pagename):
        raw = ""

    # this selects lines looking like a list item
    # !!! TODO: make multi-line quotes possible (optionally split by "----" or something)
    # !!! TODO: format the selected quote (pass through wiki parser)
    quotes = raw.splitlines()
    quotes = [quote.strip() for quote in quotes]
    quotes = [quote[2:] for quote in quotes if quote.startswith('* ')]
    
    quote = random.choice(quotes or [
        macro.formatter.highlight(1) +
        _('No quotes on %(pagename)s.') % locals() +
        macro.formatter.highlight(0)
        ])

    return quote

